'''
OpenCL Utilities

@author: Aleksandar
'''
import pyopencl as cl


def _get_best_device(dev_type):
    devices = []
    for p in cl.get_platforms():
        try:
            devices.extend(p.get_devices(dev_type))
        except:
            pass
    if not devices:
        raise RuntimeError('device not found')
    
    return sorted(devices, key=lambda dev: dev.max_compute_units)[-1]


def get_best_cpu():
    return _get_best_device(cl.device_type.CPU)


def get_best_gpu():
    return _get_best_device(cl.device_type.GPU)
